#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define MAX_MAPS	70

new g_STRING_VERSION[MAX_DATA_LENGTH]="0.8";
new g_TextFile[MAX_DATA_LENGTH]="addons/adminmod/config/maplist.ini";
new g_realentries;
new g_Maps[MAX_MAPS][MAX_NAME_LENGTH];

public admin_maps(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iLine;
	new maxline;
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iLine=strtonum(Data);
	
	if(iLine>g_realentries || iLine == 0){
		iLine=1;
	}
	maxline=iLine+9;
	if(maxline>g_realentries){
		maxline=g_realentries;
	}
	
	selfmessage( "------------- Maps: -------------");
	selfmessage( "ID  ^tMaps");
	for(i=iLine;i<=maxline;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"%i.  ^t%s",i,g_Maps[i]);
		selfmessage(Text);
	}
	selfmessage( "--------------------------------------------------");
	snprintf(Text,MAX_TEXT_LENGTH,"---^t^t^tAnzeige: %i bis %i   ^t^t  ---",iLine,maxline);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"---^t^t^tvon insg. %i Spielern^t^t  ---",g_realentries);
	selfmessage(Text);
	
	return PLUGIN_HANDLED;
}

public admin_mapid(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	i=strtonum(Data);
	
	if(i==0 || i > g_realentries){
		selfmessage("[MAP-OVERVIEW] Map not found! Use 'admin_maps'!");
		return PLUGIN_HANDLED;
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-OVERVIEW] Es wird zu '%s' gewechselt!",g_Maps[i]);
		say(Text);
		changelevel(g_Maps[i],3);
	}
	return PLUGIN_HANDLED;
}

public admin_mapfind(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)<3){
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-OVERVIEW] Bitte mehr als nur 3 Buchstaben angeben!");
		selfmessage(Text);
	}else{
		selfmessage( "------------- Map-Search: -------------");
		selfmessage( "ID  ^tMaps");
		for(i=1;i<=g_realentries;i++){
			if(strcasestrx(g_Maps[i],Data)!=-1){
				snprintf(Text,MAX_TEXT_LENGTH,"%i.  ^t%s",i,g_Maps[i]);
				selfmessage(Text);
			}
		}
	}
	return PLUGIN_HANDLED;
}

read_file(){
	new Data[MAX_NAME_LENGTH];
	new i;
	new iLine;
	
	iLine=filesize(g_TextFile);
	
	g_realentries=1;
	
	/*Damit der Array nicht berluft*/
	if(iLine>MAX_MAPS){
		iLine=MAX_MAPS;
	}
	
	for(i=0;i<=iLine;i++){
		readfile(g_TextFile,Data,i,MAX_DATA_LENGTH);
		if(strlen(Data)!=0 && strncasecmp(Data,"//",2)!=0 && strncasecmp(Data,";",1)!=0 && strncasecmp(Data,"#",1)!=0){
			strcpy(g_Maps[g_realentries],Data,MAX_NAME_LENGTH);
			g_realentries++;
		}
	}
	g_realentries--;
}

public plugin_init() {
	plugin_registerinfo("Server Map-Overwiew","Looking for a map and change to it per Map-ID",g_STRING_VERSION);
	plugin_registercmd("admin_maps","admin_maps",ACCESS_ALL,"admin_maps: Zeigt dir alle Maps auf dem Server an und die MapID.");
	plugin_registercmd("admin_mapfind","admin_mapfind",ACCESS_ALL,"admin_mapfind: Sucht die Map und gibt die entsprechende ID.");
	plugin_registercmd("admin_mapchange","admin_mapid",ACCESS_MAP,"admin_mapchange 'MAP-ID': Wechselt die Map entsprechend ihrer ID.");
	plugin_registercmd("maps","admin_maps",ACCESS_ALL,"maps : zeigt eine Liste aller Maps auf dem Server");
	read_file();
	return PLUGIN_CONTINUE;
}